export default class BitBuffer {
    /**
     * BitBuffer class is the core class for computational process,
     * shifting.
     *
     * @param MaxHalfSize - Half the size that `BitBuffer` can store
     * @param _buffer - Private property that the main data will be stored in.
     * @param _left - Left part of `_buffer`, type of this property is `BitBuffer`
     * and the size is half of the `_buffer`.
     * @param _right - Right part of `_buffer`, type of this property is `BitBuffer`
     * and the size is half of the `_buffer`.
     */
    private static readonly MaxHalfSize;
    private _left;
    private _right;
    private _buffer;
    get buffer(): number[];
    set buffer(value: number[]);
    length: number;
    get left(): BitBuffer | undefined;
    set left(value: BitBuffer | undefined);
    get right(): BitBuffer | undefined;
    set right(value: BitBuffer | undefined);
    constructor(lengthOrBuffer: number[] | number);
    constructor(left: number[], right: number[]);
    private static checkLength;
    shiftLeft(child: BitBuffer, position: number): BitBuffer;
    leftShiftLeft(position: number): void;
    leftShiftRight(position: number): void;
    swap(): BitBuffer;
    xor(second: BitBuffer): BitBuffer;
    toString(): string;
}
