"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Mapper_1 = __importDefault(require("./Mapper"));
const permutation_1 = require("../constants/permutation");
const flow_1 = require("../entity/flow");
const BitBuffer_1 = __importDefault(require("./BitBuffer"));
const keys_1 = require("../entity/keys");
class KeyGenerator {
    static generate(secretBitArray) {
        const secret = new BitBuffer_1.default(secretBitArray);
        const root = new flow_1.KeyGeneration();
        // Rearrange secret using P10
        const main = Mapper_1.default.MapPermutation(permutation_1.Permutation.P10, secret);
        root.P10 = main.toString();
        // Left Shift by 1 Left Half
        main.leftShiftLeft(1);
        root.LS1_L = main.left.toString();
        // Left Shift by 1 Right Half
        main.leftShiftRight(1);
        root.LS1_R = main.right.toString();
        // Permuted by p8
        const key1 = Mapper_1.default.MapPermutation(permutation_1.Permutation.P8, main);
        root.P8_1 = key1.toString();
        // ------------------------ Key 1 Generated ---------------------
        // Left Shift by 2 Left Half
        main.leftShiftLeft(2);
        root.LS2_L = main.left.toString();
        // Left Shift by 2 Right Half
        main.leftShiftRight(2);
        root.LS2_R = main.right.toString();
        // Permuted by p8
        const key2 = Mapper_1.default.MapPermutation(permutation_1.Permutation.P8, main);
        root.P8_2 = key2.toString();
        // ------------------------ Key 2 Generated ---------------------
        const keys = new keys_1.Keys(key1, key2);
        return [keys, root];
    }
}
exports.default = KeyGenerator;
